package org.netkernel.rdf.rdfa.endpoint;

import net.rootdev.javardfa.jena.RDFaReader.HTMLRDFaReader;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.IReadableBinaryStreamRepresentation;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.netkernel.rdf.jena.rep.JenaModelRepresentation;

import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.ModelFactory;

public class JRDFaHTMLParserAccessor extends StandardAccessorImpl
{
	public JRDFaHTMLParserAccessor()
	{	this.declareThreadSafe();
		this.declareSourceRepresentation(JenaModelRepresentation.class);
	}

	@Override
	public void onSource(INKFRequestContext aContext) throws Exception
	{
		IReadableBinaryStreamRepresentation rbs=aContext.source("arg:operand", IReadableBinaryStreamRepresentation.class);
		Model m=ModelFactory.createDefaultModel();
		HTMLRDFaReader r=new HTMLRDFaReader();
		String base;
		if(aContext.getThisRequest().argumentExists("base"))
		{	base=aContext.getThisRequest().getArgumentValue("base");
		}
		else
		{	String opd=aContext.getThisRequest().getArgumentValue("operand");
			if(opd.startsWith("http"))
			{	base=opd;
			}
			else
			{	base="http://base-not-defined/";
			}
		}
		r.read(m, rbs.getInputStream(), base);
		aContext.createResponseFrom(new JenaModelRepresentation(m));
	}
}
